unit TMS_JOSE1_frmMainU;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls;

type
  TfrmMain = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Priv: TMemo;
    Pub: TMemo;
    Label4: TLabel;
    Label5: TLabel;
    Header: TEdit;
    Payload: TEdit;
    Results: TMemo;
    Sign: TButton;
    Verify: TButton;
    jwt: TEdit;
    Label6: TLabel;
    sig: TEdit;
    Label7: TLabel;
    procedure SignClick(Sender: TObject);
    procedure VerifyClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

uses Bcl.Jose.Encoding.Base64, Bcl.Jose.Signing.RSA, RSAObj, MiscObj;

{$R *.dfm}

procedure TfrmMain.SignClick(Sender: TObject);
var
  sInput, sSig, sRes: string;
  sl : TStringList;
  s : string;
begin
  sInput := TBase64.URLEncode(Header.Text) + '.' + TBase64.URLEncode(Payload.Text);
  sSig := TBase64.URLEncode(TRSA.Sign(TEncoding.Ansi.GetBytes(sInput), TEncoding.Ansi.GetBytes(Priv.Lines.Text), TRSAAlgorithm.RS256));
  sig.Text := sSig;
  sRes := sInput + '.' + sSig;
  jwt.Text := sRes;

  Results.Lines.Add(sRes);
end;

procedure TfrmMain.VerifyClick(Sender: TObject);
begin
  try
    if TRSA.Verify(TEncoding.Ansi.GetBytes(TBase64.URLEncode(Header.Text) + '.' + TBase64.URLEncode(Payload.Text)), TEncoding.Ansi.GetBytes(sig.Text), TEncoding.Ansi.GetBytes(Pub.Lines.Text), TRSAAlgorithm.RS256) then
      Results.Lines.Add('OK')
    else
      Results.Lines.Add('!!!FAILED!!!');
  except
    on x : Exception do
      Results.Lines.Add(x.ClassName + ': ' + x.Message);
  end;
end;

end.
